searchNodes=[{"doc":"This module is basically the only module consumers of this library should be interested in. There is a single function exported: [ LibLatLon.lookup/3 ].","ref":"LibLatLon.html","title":"LibLatLon","type":"module"},{"doc":"Pass anything to lookup using default provider and with default options. Pass a provider as the second argument to use a specific provider. Pass options map like %{language: &quot;es&quot;} as a last parameter to tune the provider’s response. NB: options are provider-specific. Examples iex&gt; LibLatLon . lookup ( ...&gt; { 42 , 3.14159265 } , ...&gt; LibLatLon.Providers.Dummy , ...&gt; %{ extended : true } ) . details %{ city : &quot;Barcelona&quot; , city_district : &quot;Sant Martí&quot; , country : &quot;España&quot; , country_code : &quot;es&quot; , county : &quot;BCN&quot; , postcode : &quot;08020&quot; , road : &quot;Avinguda del Litoral&quot; , state : &quot;CAT&quot; , suburb : &quot;la Vila Olímpica del Poblenou&quot; }","ref":"LibLatLon.html#lookup/3","title":"LibLatLon.lookup/3","type":"function"},{"doc":"The default behaviour for all the geo providers. Implementations known: LibLatLon.Providers.OpenStreetMap LibLatLon.Providers.GoogleMaps Contributions are very welcome .","ref":"LibLatLon.Provider.html","title":"LibLatLon.Provider","type":"behaviour"},{"doc":"Performs either a normal lookup by any string or a reverse lookup by latitude and longitude","ref":"LibLatLon.Provider.html#c:lookup/2","title":"LibLatLon.Provider.lookup/2","type":"callback"},{"doc":"Returns a name of this provider to display","ref":"LibLatLon.Provider.html#c:name/0","title":"LibLatLon.Provider.name/0","type":"callback"},{"doc":"Convenient storage for geo bounds.","ref":"LibLatLon.Bounds.html","title":"LibLatLon.Bounds","type":"module"},{"doc":"The Bouds struct has two fields ( from and to ). from denoting the northeast boundary, and to denoting the southwest boundary. Example GoogleMaps API returns the same structure from geocoding requests: % { ... &quot;geometry&quot; =&gt; % { &quot;bounds&quot; =&gt; %{ &quot;northeast&quot; =&gt; %{ &quot;lat&quot; =&gt; 41.3884209 , &quot;lng&quot; =&gt; 2.1982486 } , &quot;southwest&quot; =&gt; %{ &quot;lat&quot; =&gt; 41.3874997 , &quot;lng&quot; =&gt; 2.1970767 } } ...","ref":"LibLatLon.Bounds.html#t:t/0","title":"LibLatLon.Bounds.t/0","type":"type"},{"doc":"Main struct to be used as coordinates representation. One might cast nearly everything to LibLatLon.Coord with LibLatLon.Coord.borrow/1 and/or LibLatLon.Coord.borrow/2 . This struct implements both String.Chars and Inspect protocols. The fancy string representation of any lat/lon pair might be get by Kernel.to_string/1 : iex&gt; to_string ( LibLatLon.Coords . borrow ( lat : 41.38 , lon : 2.19 ) ) &quot;41°22´48.0˝N,2°11´24.0˝E&quot; Note, that this representation might be used as is when querying any geolocation services and/or GoogleMaps . Try: http://maps.google.com?search=41°22´48.0˝N,2°11´24.0˝E","ref":"LibLatLon.Coords.html","title":"LibLatLon.Coords","type":"module"},{"doc":"Converts literally any input to LibLatLon.Coords instance. Examples iex&gt; LibLatLon.Coords . borrow ( &quot;41°23´16˝N,2°11´50˝E&quot; ) % LibLatLon.Coords { lat : 41.38777777777778 , lon : 2.197222222222222 } iex&gt; LibLatLon.Coords . borrow ( &quot;41°23´16.222˝N,2°11´50.333˝E&quot; ) % LibLatLon.Coords { lat : 41.387839444444445 , lon : 2.197314722222222 } iex&gt; LibLatLon.Coords . borrow ( { { { 41 , 23 , 16.0 } , &quot;N&quot; } , { { 2 , 11 , 50.0 } , &quot;E&quot; } } ) % LibLatLon.Coords { lat : 41.38777777777778 , lon : 2.197222222222222 } iex&gt; LibLatLon.Coords . borrow ( lat : 41.38 , lon : 2.19 ) % LibLatLon.Coords { lat : 41.38 , lon : 2.19 }","ref":"LibLatLon.Coords.html#borrow/1","title":"LibLatLon.Coords.borrow/1","type":"function"},{"doc":"Converts {{degree, minute, second}, semisphere} or {[degree, minute, second], semisphere} representation into LibLatLon.Coords .","ref":"LibLatLon.Coords.html#borrow/2","title":"LibLatLon.Coords.borrow/2","type":"function"},{"doc":"Converts degree, minute, second, semisphere representation into LibLatLon.Coords . When the last parameter semisphere is not one of: &quot;S&quot; or &quot;W&quot; or -1 or :south or west , it is implicitly considered to be in NE semisphere.","ref":"LibLatLon.Coords.html#borrow/4","title":"LibLatLon.Coords.borrow/4","type":"function"},{"doc":"Same as LibLatLon.Coords.coordinate/1 , but banged. Examples iex&gt; LibLatLon.Coords . coordinate! ( &quot;test/inputs/1.jpg&quot; ) # Coord &lt; [ lat : 41.37600333333334 , lon : 2.1486783333333332 , fancy : &quot;41°22´33.612˝N,2°8´55.242˝E&quot; ] &gt;","ref":"LibLatLon.Coords.html#coordinate!/1","title":"LibLatLon.Coords.coordinate!/1","type":"function"},{"doc":"Retrieves coordinates from barely anything. iex&gt; { :ok , result } = LibLatLon.Coords . coordinate ( &quot;test/inputs/1.jpg&quot; ) ...&gt; result # Coord &lt; [ lat : 41.37600333333334 , lon : 2.1486783333333332 , fancy : &quot;41°22´33.612˝N,2°8´55.242˝E&quot; ] &gt; iex&gt; LibLatLon.Coords . coordinate ( &quot;test/inputs/unknown.jpg&quot; ) { :error , { :weird_input , [ nil ] } }","ref":"LibLatLon.Coords.html#coordinate/1","title":"LibLatLon.Coords.coordinate/1","type":"function"},{"doc":"Converts literally anything, provided as combined latlon value to two tuples {{degree, minute, second}, semisphere} . Barely used from the outside the package, since LibLatLon.Coords.t is obviously better type to work with coordinates by all means. Examples iex&gt; LibLatLon.Coords . lend ( { 41.38777777777778 , 2.197222222222222 } ) { { { 41 , 23 , 16.0 } , &quot;N&quot; } , { { 2 , 11 , 50.0 } , &quot;E&quot; } } iex&gt; LibLatLon.Coords . lend ( [ 41.38777777777778 , 2.197222222222222 ] ) { { { 41 , 23 , 16.0 } , &quot;N&quot; } , { { 2 , 11 , 50.0 } , &quot;E&quot; } }","ref":"LibLatLon.Coords.html#lend/1","title":"LibLatLon.Coords.lend/1","type":"function"},{"doc":"Converts literally anything, provided as latitude and longitude values to two tuples {{degree, minute, second}, semisphere} . Barely used from the outside the package, since LibLatLon.Coords.t is obviously better type to work with coordinates by all means. Examples iex&gt; LibLatLon.Coords . lend ( 41.38777777777778 , 2.197222222222222 ) { { { 41 , 23 , 16.0 } , &quot;N&quot; } , { { 2 , 11 , 50.0 } , &quot;E&quot; } }","ref":"LibLatLon.Coords.html#lend/2","title":"LibLatLon.Coords.lend/2","type":"function"},{"doc":"Degrees, minutes and seconds as a tuple","ref":"LibLatLon.Coords.html#t:dms/0","title":"LibLatLon.Coords.dms/0","type":"type"},{"doc":"Degrees, minutes and seconds as a list","ref":"LibLatLon.Coords.html#t:dms_list/0","title":"LibLatLon.Coords.dms_list/0","type":"type"},{"doc":"Degrees, minutes and seconds with an optional semisphere reference","ref":"LibLatLon.Coords.html#t:dms_ss/0","title":"LibLatLon.Coords.dms_ss/0","type":"type"},{"doc":"The type to store coordinates. Mostly used fields are lat and lon , stored as Float.t . Also might contain altitude and direction to calculate the latitude and langitude for the destination point (mostly used when dealing with EXIF information from images.)","ref":"LibLatLon.Coords.html#t:t/0","title":"LibLatLon.Coords.t/0","type":"type"},{"doc":"Main storage struct for holding information about any place/POI/address in the unified form. Example: LibLatLon . lookup { 41.38777777777778 , 2.197222222222222 } % LibLatLon.Info { address : &quot;Avinguda del Litoral, [...] España&quot; , bounds : % LibLatLon.Bounds { from : # Coord &lt; [ lat : 41.3876663 , lon : 2.196602 , fancy : &quot;41°23´15.59868˝N,2°11´47.7672˝E&quot; ] &gt; , to : # Coord &lt; [ lat : 41.3917431 , lon : 2.2031084 , fancy : &quot;41°23´30.27516˝N,2°12´11.19024˝E&quot; ] &gt; } , coords : # Coord &lt; [ lat : 41.3899932 , lon : 2.2000054 , fancy : &quot;41°23´23.97552˝N,2°12´0.01944˝E&quot; ] &gt; , details : %{ city : &quot;Barcelona&quot; , city_district : &quot;Sant Martí&quot; , country : &quot;España&quot; , country_code : &quot;es&quot; , county : &quot;BCN&quot; , postcode : &quot;08020&quot; , road : &quot;Avinguda del Litoral&quot; , state : &quot;CAT&quot; , suburb : &quot;la Vila Olímpica del Poblenou&quot; } , meta : %{ licence : &quot;Data © OpenStreetMap [...]&quot; , osm_id : &quot;47123759&quot; , osm_type : &quot;way&quot; , place_id : &quot;82181109&quot; } }","ref":"LibLatLon.Info.html","title":"LibLatLon.Info","type":"module"},{"doc":"Formats the String.t representation of this struct according to the format given. Second parameter format might include %{field} inclusions which will be interpolated in the result with real values. Examples iex&gt; info = LibLatLon . lookup ( { 42 , 3.14159265 } , LibLatLon.Providers.Dummy ) iex&gt; LibLatLon.Info . format ( info , &quot;⚑ %{country}, %{city}, %{postcode}.&quot; ) &quot;⚑ España, Barcelona, 08021.&quot;","ref":"LibLatLon.Info.html#format/2","title":"LibLatLon.Info.format/2","type":"function"},{"doc":"The same as LibLatLon.Info.from_map/1 , but banged.","ref":"LibLatLon.Info.html#from_map!/1","title":"LibLatLon.Info.from_map!/1","type":"function"},{"doc":"Mostly internal helper. You would unlikely call this function yourself. Gets the map as returned by geo location provider and contructs fields in unified format.","ref":"LibLatLon.Info.html#from_map/1","title":"LibLatLon.Info.from_map/1","type":"function"},{"doc":"Main type to store geo point in unified form. LibLatLon.Bounds.t for bounds field LibLatLon.Coords.t for coords key address is a string, representing the whole address in human-readable form. details and meta are not unified maps of fields, as returned by geo location provider. Their keys differ for different providers.","ref":"LibLatLon.Info.html#t:t/0","title":"LibLatLon.Info.t/0","type":"type"},{"doc":"GoogleMaps provider implementation.","ref":"LibLatLon.Providers.GoogleMaps.html","title":"LibLatLon.Providers.GoogleMaps","type":"module"},{"doc":"Implements a lookup for GoogleMaps provider. Returns either {:ok, %LibLatLon.Info{}} or {:error, reason} tuple. Used internally by LibLatLon.lookup/1 .","ref":"LibLatLon.Providers.GoogleMaps.html#lookup/2","title":"LibLatLon.Providers.GoogleMaps.lookup/2","type":"function"},{"doc":"OpenStreetMap provider implementation.","ref":"LibLatLon.Providers.OpenStreetMap.html","title":"LibLatLon.Providers.OpenStreetMap","type":"module"},{"doc":"Implements a lookup for OpenStreetMap provider. Returns either {:ok, %LibLatLon.Info{}} or {:error, reason} tuple. Used internally by LibLatLon.lookup/1 .","ref":"LibLatLon.Providers.OpenStreetMap.html#lookup/2","title":"LibLatLon.Providers.OpenStreetMap.lookup/2","type":"function"},{"doc":"handy library for managing geo coordinates that includes direct/reverse geocoding features.","ref":"intro.html","title":"LibLatLon","type":"extras"},{"doc":"def deps do [ { :lib_lat_lon , &quot;~&gt; 0.1&quot; } ] end Usage Reverse lookup LibLatLon . lookup { 41.38777777777778 , 2.197222222222222 } % LibLatLon.Info { address : &quot;Avinguda del Litoral, [...] España&quot; , bounds : % LibLatLon.Bounds { from : # Coord &lt; [ lat : 41.3876663 , lon : 2.196602 , fancy : &quot;41°23´15.59868˝N,2°11´47.7672˝E&quot; ] &gt; , to : # Coord &lt; [ lat : 41.3917431 , lon : 2.2031084 , fancy : &quot;41°23´30.27516˝N,2°12´11.19024˝E&quot; ] &gt; } , coords : # Coord &lt; [ lat : 41.3899932 , lon : 2.2000054 , fancy : &quot;41°23´23.97552˝N,2°12´0.01944˝E&quot; ] &gt; , details : %{ city : &quot;Barcelona&quot; , city_district : &quot;Sant Martí&quot; , country : &quot;España&quot; , country_code : &quot;es&quot; , county : &quot;BCN&quot; , postcode : &quot;08020&quot; , road : &quot;Avinguda del Litoral&quot; , state : &quot;CAT&quot; , suburb : &quot;la Vila Olímpica del Poblenou&quot; } , meta : %{ licence : &quot;Data © OpenStreetMap [...]&quot; , osm_id : &quot;47123759&quot; , osm_type : &quot;way&quot; , place_id : &quot;82181109&quot; } } Direct lookup, using GoogleMaps LibLatLon . lookup ( &quot;Av. del Litoral, 28, 08005 Barcelona, Spain&quot; , LibLatLon.Providers.GoogleMaps ) % LibLatLon.Info { address : &quot;Av. del Litoral, 28, 08005 Barcelona, Spain&quot; , bounds : % LibLatLon.Bounds { from : # Coord &lt; [ lat : 41.3893258802915 , lon : 2.198497180291502 , fancy : &quot;41°23´21.57316905˝N,2°11´54.58984905˝E&quot; ] &gt; , to : # Coord &lt; [ lat : 41.3866279197085 , lon : 2.195799219708499 , fancy : &quot;41°23´11.86051095˝N,2°11´44.87719095˝E&quot; ] &gt; } , coords : # Coord &lt; [ lat : 41.3879769 , lon : 2.1971482 , fancy : &quot;41°23´16.71684˝N,2°11´49.73352˝E&quot; ] &gt; , details : %{ administrative_area_level_1 : &quot;Catalunya&quot; , administrative_area_level_2 : &quot;Barcelona&quot; , country : &quot;Spain&quot; , locality : &quot;Barcelona&quot; , postal_code : &quot;08005&quot; , route : &quot;Avinguda del Litoral&quot; , street_number : &quot;28&quot; } , meta : %{ place_id : &quot;ChIJB801WA6jpBIRLvQ6BHMtKB4&quot; , types : [ &quot;street_address&quot; ] } } Currently supported providers GoogleMaps ; OpenStreetMaps . Currently supported sources latitude/longitude pair in any form (e.g. {lat, lon} tuple); an address as a binary() ; a jpeg image with gps information. Notes about GoogleMaps To use LibLatLon.Providers.GoogleMaps provider, go get API key from Google and put the following lines into your config.exs file: config :lib_lat_lon , :provider , LibLatLon.Providers.GoogleMaps config :lib_lat_lon , :google_maps_api_key , &quot;YOUR_GOOGLE_API_KEY&quot; or, alternatively, use the system environment variable GOOGLE_MAPS_API_KEY . Docs / Changelog Documentation can be found at https://hexdocs.pm/lib_lat_lon .","ref":"intro.html#installation","title":"LibLatLon - Installation","type":"extras"}]